
package de.ivu.elect.business.kandidatur.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractErsatzkandidaturEdit {

  @Inject
  protected ErsatzkandidaturDAO dao;

  @Inject
  protected ErsatzkandidaturExtendedDAO extendedDao;

  public void delete(Ersatzkandidatur entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Ersatzkandidatur entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Ersatzkandidatur entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Ersatzkandidatur getAttachedEntity(Ersatzkandidatur entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Ersatzkandidatur getAttachedAndRefreshedEntity(Ersatzkandidatur entity) {
    return dao.refresh(entity);
  }
}
